dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "mods/mnee/lib.lua" )

function world2gui( gui, x, y )
	local w, h = GuiGetScreenDimensions( gui )
	local cam_x, cam_y = GameGetCameraPos()
	local shit_from_ass = w/( MagicNumbersGetValue( "VIRTUAL_RESOLUTION_X" ) + MagicNumbersGetValue( "VIRTUAL_RESOLUTION_OFFSET_X" ))
	
	return w/2 + shit_from_ass*( x - cam_x ), h/2 + shit_from_ass*( y - cam_y ), shit_from_ass
end

function get_storage( hooman, name )
	local comps = EntityGetComponentIncludingDisabled( hooman, "VariableStorageComponent" ) or {}
	if( #comps > 0 ) then
		for i,comp in ipairs( comps ) do
			if( ComponentGetValue2( comp, "name" ) == name ) then
				return comp
			end
		end
	end
	
	return nil
end

function new_image( gui, uid, pic_x, pic_y, pic_z, pic, s_x, s_y, alpha, interactive )
	if( not( interactive or false )) then
		GuiOptionsAddForNextWidget( gui, 2 ) --NonInteractive
	end
	GuiZSetForNextWidget( gui, pic_z )
	uid = uid + 1
	GuiIdPush( gui, uid )
	GuiImage( gui, uid, pic_x, pic_y, pic, alpha or 1, s_x or 1, s_y or 1 )
	return uid
end



local entity_id = GetUpdatedEntityID()
local x, y, r, s_x, s_y = EntityGetTransform( entity_id )

local frame_num = GameGetFrameNum()
local timer = ComponentGetValue2( GetUpdatedComponentID(), "mTimesExecuted" )

local storage_angle = get_storage( entity_id, "kappa_angle" )
local angle = ComponentGetValue2( storage_angle, "value_float" )
local storage_ranged = get_storage( entity_id, "kappa_ranged_cooldown" )
local ranged_cooldown = ComponentGetValue2( storage_ranged, "value_int" )
local storage_melee = get_storage( entity_id, "kappa_melee_cooldown" )
local melee_cooldown = ComponentGetValue2( storage_melee, "value_int" )
local storage_gun = get_storage( entity_id, "kappa_current_gun" )
local current_gun = ComponentGetValue2( storage_gun, "value_int" )

local ai_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "AnimalAIComponent" )
if( ComponentGetIsEnabled( ai_comp )) then
	EntitySetComponentIsEnabled( entity_id, ai_comp, false )
end

local hands_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "ItemPickUpperComponent" )
local char_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "CharacterDataComponent" )
local plat_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "CharacterPlatformingComponent" )
local dmg_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "DamageModelComponent" )
local hitbox_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "HitboxComponent" )
local attack_comps = EntityGetComponentIncludingDisabled( entity_id, "AIAttackComponent" ) or {}
local attack_comp = attack_comps[current_gun]

local ctrl_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "ControlsComponent" )
ComponentSetValue2( ctrl_comp, "mButtonDownRun", true )
local move_left = is_binding_down( "kappa", "ab_left", true ) or get_axis_state( "kappa", "ab_movement_h", true ) < 0
local move_right = is_binding_down( "kappa", "ad_right", true ) or get_axis_state( "kappa", "ab_movement_h", true ) > 0
ComponentSetValue2( ctrl_comp, "mButtonDownLeft", move_left )
ComponentSetValue2( ctrl_comp, "mButtonDownRight", move_right )

if( ModSettingGetNextValue( "kappa.UNSTABLE_MODE" )) then
	ComponentSetValue2( ctrl_comp, "mButtonDownDown", is_binding_down( "kappa", "ac_down", true ) or get_axis_state( "kappa", "aa_movement_v", true ) > 0 )
end

local inv_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "Inventory2Component" )
local wand_in_hand = -1
if( inv_comp ~= nil ) then
	wand_in_hand = tonumber( ComponentGetValue2( inv_comp, "mActiveItem" ) or -1 )
end

local is_coop = ModSettingGetNextValue( "kappa.GLOBAL_MODE" ) == 2
if( is_coop ) then
	local hooman = EntityGetClosestWithTag( x, y, "player_unit" ) or 0
	if( hooman > 0 ) then
		local player_x, player_y = EntityGetTransform( hooman )
		local d_x, d_y = player_x - x, player_y - y
		local dist = math.sqrt( d_x^2 + d_y^2 )
		if( dist < tonumber( MagicNumbersGetValue( "VIRTUAL_RESOLUTION_X" ))) then
			local shooter_comp = EntityGetFirstComponentIncludingDisabled( hooman, "PlatformShooterPlayerComponent" )
			if( shooter_comp ~= nil ) then
				local cam_pos = { ComponentGetValue2( shooter_comp, "mSmoothedCameraPosition" )}
				local wanna_pos = { player_x - d_x/2, player_y - d_y/2 }
				local smoothing = 15
				ComponentSetValue2( shooter_comp, "mSmoothedCameraPosition", cam_pos[1] + ( wanna_pos[1] - cam_pos[1] )/smoothing, cam_pos[2] + ( wanna_pos[2] - cam_pos[2] )/smoothing )
			end
		end
	end
end



local a_dist = 100
local a_speed = math.rad( 1 )
local a_limit = math.rad( 85 )

local look_up = is_binding_down( "kappa", "af_aim_down", true )
local look_down = is_binding_down( "kappa", "ae_aim_up", true )
local aim_v, aim_h = get_axis_state( "kappa", "ac_aim_v", true ), get_axis_state( "kappa", "ad_aim_h", true )

local keyboard_moment = look_up or look_down or move_left or move_right
local controller_moment = aim_v ~= 0 or aim_h ~= 0
if( plat_comp ~= nil ) then
	if( keyboard_moment or controller_moment ) then
		ComponentSetValue2( plat_comp, "keyboard_look", not( controller_moment ))
		ComponentSetValue2( plat_comp, "mouse_look", controller_moment )
	end
end

if( look_up or look_down or controller_moment ) then
	if( controller_moment ) then
		angle = math.atan2( aim_v, get_sign( s_x )*aim_h )
	else
		angle = math.max( math.min( angle - ( look_up and 1 or -1 )*a_speed, a_limit ), -a_limit )
	end
	ComponentSetValue2( storage_angle, "value_float", angle )
	
	if( attack_comp ~= nil and ComponentGetValue2( attack_comp, "attack_ranged_aim_rotation_enabled" )) then
		GameEntityPlaySoundLoop( entity_id, "turret_rotate_sound", 1.0 )
	end
end
a_vector = { s_x*math.cos( angle )*a_dist, s_y*math.sin( angle )*a_dist }
ComponentSetValue2( ctrl_comp, "mAimingVector", a_vector[1], a_vector[2] )
ComponentSetValue2( ctrl_comp, "mMousePosition", a_vector[1]*1000, a_vector[2]*1000 )

local next_gun = get_binding_pressed( "kappa", "ag_next_gun" )
local previous_gun = get_binding_pressed( "kappa", "ah_previous_gun" )
if( next_gun or previous_gun ) then
	current_gun = current_gun + ( next_gun and 1 or -1 )
	if( current_gun < 1 ) then
		current_gun = #attack_comps
	elseif( current_gun > #attack_comps ) then
		current_gun = 1
	end
	ComponentSetValue2( storage_gun, "value_int", math.max( current_gun, 1 ))
	
	GamePlaySound( "mods/kappa/sfx/kappa.bank", "gun_switch", x, y )
end

local gonna_shoot = is_binding_down( "kappa", "ai_shoot", true )
local gonna_melee = is_binding_down( "kappa", "aj_melee", true )

local gun_dude = entity_id
if( attack_comp ~= nil ) then
	local kids = EntityGetAllChildren( entity_id ) or {}
	if( #kids > 0 ) then
		for i,kid in ipairs( kids ) do
			if( EntityGetName( kid ) == "gun_kid" ) then
				gun_dude = kid
				break
			end
		end
		if( gun_dude ~= entity_id ) then
			local trans_comp = EntityGetFirstComponentIncludingDisabled( gun_dude, "InheritTransformComponent" )
			local origs = { ComponentGetValue2( trans_comp, "Transform" ) }
			ComponentSetValue2( trans_comp, "Transform", origs[1], origs[2], origs[3], origs[4], s_x*angle )
			
			if( not( gonna_shoot )) then
				EntityRefreshSprite( gun_dude, EntityGetFirstComponentIncludingDisabled( gun_dude, "SpriteComponent", "kids_gun" ))
				GamePlayAnimation( gun_dude, "stand", 0.1 )
			end
		end
	end
end

if( wand_in_hand > 0 ) then
	ComponentSetValue2( ctrl_comp, "mButtonDownFire", gonna_shoot )
	ComponentSetValue2( EntityGetFirstComponentIncludingDisabled( entity_id, "PlatformShooterPlayerComponent" ), "mForceFireOnNextUpdate", gonna_shoot )
elseif( ComponentGetValue2( ai_comp, "attack_ranged_enabled" ) or attack_comp ~= nil ) then
	if( ranged_cooldown < frame_num and gonna_shoot ) then
		local barrel_x, barrel_y, amount, cooldown, path, anim = 0, 0, 1, 0, "", "attack_ranged"
		
		if( attack_comp ~= nil ) then
			local off_x, off_y = ComponentGetValue2( attack_comp, "attack_ranged_offset_x" ), ComponentGetValue2( attack_comp, "attack_ranged_offset_y" )
			barrel_x, barrel_y = off_x*math.cos( angle ), off_x*math.sin( angle )
			barrel_x, barrel_y = barrel_x + off_y*math.cos( angle + math.rad( 90 )), barrel_y + off_y*math.sin( angle + math.rad( 90 ))
			barrel_x, barrel_y = barrel_x + ComponentGetValue2( attack_comp, "attack_ranged_root_offset_x" ), barrel_y + ComponentGetValue2( attack_comp, "attack_ranged_root_offset_y" )
			
			amount = math.random( ComponentGetValue2( attack_comp, "attack_ranged_entity_count_min" ), ComponentGetValue2( attack_comp, "attack_ranged_entity_count_max" ))
			
			cooldown = ( 2*ComponentGetValue2( attack_comp, "frames_between_global" ) + ComponentGetValue2( attack_comp, "frames_between" ))/3
			path = ComponentGetValue2( attack_comp, "attack_ranged_entity_file" )
			anim = ComponentGetValue2( attack_comp, "animation_name" )
		else
			barrel_x, barrel_y = ComponentGetValue2( ai_comp, "attack_ranged_offset_x" ), ComponentGetValue2( ai_comp, "attack_ranged_offset_y" )
			amount = math.random( ComponentGetValue2( ai_comp, "attack_ranged_entity_count_min" ), ComponentGetValue2( ai_comp, "attack_ranged_entity_count_max" ))
			cooldown = ComponentGetValue2( ai_comp, "attack_ranged_frames_between" )
			path = ComponentGetValue2( ai_comp, "attack_ranged_entity_file" )
		end
		
		barrel_x, barrel_y = x + s_x*barrel_x, y + s_y*barrel_y
		for i = 1,amount do
			local proj_id = shoot_projectile( entity_id, path, barrel_x, barrel_y, 0, 0 )
			edit_component( proj_id, "ProjectileComponent", function(comp,vars)
				if( not( ComponentGetValue2( ai_comp, "tries_to_ranged_attack_friends" ))) then
					ComponentSetValue2( comp, "never_hit_player", is_coop or ComponentGetValue2( comp, "never_hit_player" ))
				end
				
				local shoot_speed = math.random( ComponentGetValue2( comp, "speed_min" ), ComponentGetValue2( comp, "speed_max" ))
				local v_x, v_y = shoot_speed*a_vector[1]/100, shoot_speed*a_vector[2]/100
				
				local shape_comp = EntityGetFirstComponentIncludingDisabled( proj_id, "PhysicsImageShapeComponent" )
				if( shape_comp ~= nil ) then
					local proj_x, proj_y = EntityGetTransform( proj_id )
					local drift_x, drift_y = ComponentGetValue2( shape_comp, "offset_x" ), ComponentGetValue2( shape_comp, "offset_y" )
					proj_x, proj_y = proj_x - drift_x, proj_y - drift_y
					drift_x, drift_y = 1.5*drift_x, 1.5*drift_y
					
					local function get_phys_mass( entity_id )
						local mass = 0
						local function calculate_force_for_body( entity, body_mass, body_x, body_y, body_vel_x, body_vel_y, body_vel_angular )
							if( math.abs( proj_x - body_x ) < 0.001 and math.abs( proj_y - body_y ) < 0.001 ) then
								mass = body_mass
							end
							return body_x, body_y, 0, 0, 0
						end
						PhysicsApplyForceOnArea( calculate_force_for_body, nil, proj_x - drift_x, proj_y - drift_y, proj_x + drift_x, proj_y + drift_y )
						
						return mass
					end
					local gravity = 60
					local weight = gravity*get_phys_mass( proj_id )
					v_x, v_y = GameVecToPhysicsVec( weight*v_x, weight*v_y )
					PhysicsApplyForce( proj_id, 2*v_x, 2*v_y )
				elseif( EntityGetFirstComponentIncludingDisabled( proj_id, "VerletWeaponComponent" ) ~= nil ) then
					EntityKill( proj_id )
					shoot_projectile( entity_id, path, barrel_x, barrel_y, v_x, v_y )
				else
					edit_component( proj_id, "VelocityComponent", function(comp,vars)
						ComponentSetValueVector2( comp, "mVelocity", v_x, v_y )
					end)
				end
			end)
		end
		
		local kid_pic = EntityGetFirstComponentIncludingDisabled( gun_dude, "SpriteComponent", "kids_gun" )
		if( kid_pic ~= nil ) then
			EntityRefreshSprite( gun_dude, kid_pic )
		end
		
		GamePlayAnimation( gun_dude, anim, 1 )
		ComponentSetValue2( storage_ranged, "value_int", frame_num + cooldown )
	end
else
	gonna_melee = gonna_melee or gonna_shoot
end
if( ComponentGetValue2( ai_comp, "attack_melee_enabled" )) then
	ComponentSetValue2( ctrl_comp, "mButtonDownKick", gonna_melee )
	if( melee_cooldown < frame_num and gonna_melee ) then
		local barrel_x, barrel_y = s_x*ComponentGetValue2( ai_comp, "attack_melee_offset_x" ), s_y*ComponentGetValue2( ai_comp, "attack_melee_offset_y" )
		local force = ComponentGetValue2( ai_comp, "attack_melee_impulse_multiplier" )
		local force_x, force_y = force*s_x*ComponentGetValue2( ai_comp, "attack_melee_impulse_vector_x" ), -force*s_y*ComponentGetValue2( ai_comp, "attack_melee_impulse_vector_y" )
		local dmg = { ComponentGetValue2( ai_comp, "attack_melee_damage_min" ), ComponentGetValue2( ai_comp, "attack_melee_damage_max" ), }
		local radius = ComponentGetValue2( ai_comp, "attack_melee_max_distance" )
		local fuck_player = true
		
		if( ComponentGetValue2( ai_comp, "attack_dash_enabled" )) then
			local extra_damage = ComponentGetValue2( ai_comp, "attack_dash_damage" )
			dmg = { dmg[1] + extra_damage, dmg[2] + extra_damage, }
		end
		
		local meats = EntityGetInRadius( x + barrel_x, y + barrel_y, radius ) or {}
		if( #meats > 0 ) then
			for i,meat in ipairs( meats ) do
				if( meat ~= entity_id and EntityGetRootEntity( meat ) == meat ) then
					if( EntityGetFirstComponentIncludingDisabled( meat, "DamageModelComponent" ) ~= nil ) then
						local gene_comp = EntityGetFirstComponentIncludingDisabled( meat, "GenomeDataComponent" )
						if( not( is_coop ) or ( gene_comp == nil ) or ( gene_comp ~= nil and ComponentGetValue2( gene_comp, "herd_id" ) ~= StringToHerdId( "player" ))) then
							local m_x, m_y = EntityGetTransform( meat )
							EntityInflictDamage( meat, math.random( dmg[1], dmg[2] ), "DAMAGE_MELEE", "Gotcha", "BLOOD_SPRAY", force_x, force_y, entity_id, m_x, m_y, force )
						end
					end
				end
			end
		end
		
		GamePlayAnimation( entity_id, "attack", 1 )
		ComponentSetValue2( storage_melee, "value_int", frame_num + ComponentGetValue2( ai_comp, "attack_melee_frames_between" ))
	end
end

local gonna_fly = is_binding_down( "kappa", "aa_up", true ) or get_axis_state( "kappa", "aa_movement_v", true ) < 0
if( gonna_fly ) then
	ComponentSetValue2( plat_comp, "mSmoothedFlyingTargetY", -999999 )
end
if( ComponentGetValue2( ai_comp, "can_fly" )) then
	ComponentSetValue2( ctrl_comp, "mButtonDownFly", gonna_fly )
elseif(( ComponentGetValue2( char_comp, "is_on_ground" ) and gonna_fly ) or ( ComponentGetValue2( dmg_comp, "mAirAreWeInWater" ) and get_binding_pressed( "kappa", "aa_up", nil, true ))) then
	local j_x, j_y = 0, 0
	if( ComponentGetValue2( ai_comp, "attack_dash_enabled" )) then
		local speed = math.max( ComponentGetValue2( ai_comp, "attack_dash_speed" ), 200 )
		j_x, j_y = speed*s_x*math.cos( angle - math.rad( 10 )), speed*s_y*math.sin( angle - math.rad( 10 ))
	else
		j_x, j_y = ComponentGetValue2( plat_comp, "jump_velocity_x" ), math.min( ComponentGetValue2( plat_comp, "jump_velocity_y" ), -200 )
	end
	local v_x, v_y = ComponentGetValue2( char_comp, "mVelocity" )
	ComponentSetValueVector2( char_comp, "mVelocity", v_x + j_x, v_y + j_y )
	GamePlayAnimation( entity_id, "jump_up", 1 )
end

if( ModSettingGetNextValue( "kappa.KAPPA_CONCRETE_HANDS" ) and timer < 10 and wand_in_hand > 0 ) then
	local item_comp = EntityGetFirstComponentIncludingDisabled( wand_in_hand, "ItemComponent" )
	if( item_comp ~= nil and not( ComponentGetValue2( item_comp, "has_been_picked_by_player" ))) then
		local abil_comp = EntityGetFirstComponentIncludingDisabled( wand_in_hand, "AbilityComponent" )
		if( abil_comp ~= nil ) then
			ComponentSetValue2( abil_comp, "drop_as_item_on_death", false )
			
			EntityAddComponent( wand_in_hand, "LuaComponent", 
			{
				_tags = "enabled_in_world",
				script_source_file = "mods/kappa/wand_nuker.lua",
				execute_every_n_frame = "1",
			})
		end
	end
elseif( timer > 10 ) then
	if( hands_comp ~= nil and ComponentGetIsEnabled( hands_comp )) then
		EntitySetComponentIsEnabled( entity_id, hands_comp, false )
	end
end
if( get_binding_pressed( "kappa", "ak_drop" )) then
	GameDropAllItems( entity_id )
	if( hands_comp ~= nil ) then
		EntitySetComponentIsEnabled( entity_id, hands_comp, true )
	end
end

if( ModSettingGetNextValue( "kappa.SOLID_SCREEN" )) then
	local pos_x, pos_y, width, height = GameGetCameraBounds()
	local new_x = math.min( math.max( x, pos_x ), pos_x + width )
	local new_y = math.min( math.max( y, pos_y ), pos_y + height )
	if( new_x ~= x or new_y ~= y ) then
		EntitySetTransform( entity_id, new_x, new_y )
	end
end
if( ModSettingGetNextValue( "kappa.NO_SUICIDES" )) then
	local duds = EntityGetInRadiusWithTag( x, y, 2*MagicNumbersGetValue( "VIRTUAL_RESOLUTION_X" ), "player_unit" ) or {}
	if( #duds == 0 ) then
		EntityKill( entity_id )
		return
	end
else
	if( get_binding_pressed( "kappa", "al_suicide" )) then
		if( is_coop ) then
			if( hands_comp ~= nil ) then
				ComponentSetValue2( hands_comp, "drop_items_on_death", false )
			end
		end
		
		EntityInflictDamage( entity_id, 9999999, "DAMAGE_SLICE", "GET KAPPAED LOL", "BLOOD_EXPLOSION", 0, 0, entity_id, x, y, 0 )
		if( EntityHasTag( entity_id, "godlike" )) then
			EntityLoad( "data/entities/projectiles/deck/black_hole_giga.xml", x, y )
			EntityLoad( "data/entities/projectiles/deck/nuke_giga.xml", x, y )
			EntityLoad( "data/entities/projectiles/bomb_holy_giga.xml", x, y )
		end
	end
end

if( EntityHasTag( entity_id, "godlike" )) then
	GameEntityPlaySoundLoop( entity_id, "godlike", 1.0 )
end



local uid, pic_x, pic_y, pic_z = 0, 0, 0, -99999

local gui = GuiCreate()
GuiStartFrame( gui )

if( ModSettingGetNextValue( "kappa.SHOW_POINTER" )) then
	local w, h = GuiGetScreenDimensions( gui )
	pic_x, pic_y = world2gui( gui, x, y + ComponentGetValue2( hitbox_comp, "aabb_min_y" ) - 10 )
	local pic = "mods/kappa/pointer/pointer"
	if( pic_x >= w and pic_y >= h ) then
		pic = pic.."_se"
		pic_x = w - 2.5
		pic_y = h - 2.5
	elseif( pic_x <= 0 and pic_y >= h ) then
		pic = pic.."_sw"
		pic_x = 1.5
		pic_y = h - 2.5
	elseif( pic_x <= 0 and pic_y <= 0 ) then
		pic = pic.."_nw"
		pic_x = 1.5
		pic_y = 1.5
	elseif( pic_x >= w and pic_y <= 0 ) then
		pic = pic.."_ne"
		pic_x = w - 2.5
		pic_y = 1.5
	elseif( pic_x < 0 and pic_y > 0 ) then
		pic = pic.."_w"
		pic_x = 1.5
	elseif( pic_x > 0 and pic_y < 0 ) then
		pic = pic.."_n"
		pic_y = 1.5
	elseif( pic_x > w and pic_y < h ) then
		pic = pic.."_e"
		pic_x = w - 1.5
	elseif( pic_x > 0 and pic_y > h ) then
		pic = pic.."_s"
		pic_y = h - 1.5
	else
		pic = pic.."_s"
	end
	uid = new_image( gui, uid, pic_x - 1.5, pic_y - 1.5, pic_z, pic..".png" )
end

if( ModSettingGetNextValue( "kappa.SHOW_AIM" )) then
	local drift = math.abs( s_x > 0 and ComponentGetValue2( hitbox_comp, "aabb_max_x" ) or ComponentGetValue2( hitbox_comp, "aabb_min_x" )) + 20
	local a_x, a_y = s_x*math.cos( angle ), s_y*math.sin( angle )
	pic_x, pic_y = world2gui( gui, x + drift*a_x, y + drift*a_y )
	uid = new_image( gui, uid, pic_x - 1.5, pic_y - 1.5, pic_z - 1, "mods/kappa/pointer/pointer.png" )
end

if( ModSettingGetNextValue( "kappa.SHOW_UI" )) then
	local length = math.max( math.abs( ComponentGetValue2( hitbox_comp, "aabb_max_x" ) - ComponentGetValue2( hitbox_comp, "aabb_min_x" )), 10 )
	local percentage = math.min( math.max( ComponentGetValue2( dmg_comp, "hp" )/ComponentGetValue2( dmg_comp, "max_hp" ), 0 ), 1 )
	
	pic_x, pic_y = world2gui( gui, x, y + ComponentGetValue2( hitbox_comp, "aabb_max_y" ) + 5 )
	
	uid = new_image( gui, uid, pic_x - length/2, pic_y, pic_z - 0.5, "mods/kappa/pixels_white.png", length, 2 )
	uid = new_image( gui, uid, pic_x - length/2 + 1, pic_y + 1, pic_z - 0.6, "mods/kappa/pixels_red.png", ( length - 2 )*percentage, 1 )
	
	if( #attack_comps > 1 ) then
		pic_x, pic_y = pic_x - ( #attack_comps*2 - 1 )/2, pic_y + 7
		for i = 1,#attack_comps do
			local this_one = current_gun == i
			uid = new_image( gui, uid, pic_x + 2*( i - 1 ), pic_y, pic_z - 0.5, "mods/kappa/pixels_"..( this_one and "white" or "blue" )..".png", 1, this_one and 4/3 or 1 )
		end
	end
end

GuiDestroy( gui )